jj-squash(1)

NAME
jj-squash - Move changes from a revision into another revision

SYNOPSIS
jj squash [-r|--revision] [-f|--from] [-t|--into] [-o|--onto] [-A|--insert-after] [-B|--insert-before] [-m|--message] [-u|--use-destination-message] [--editor] [-i|--interactive] [--tool] [-k|--keep-emptied] [-R|--repository] [--ignore-working-copy] [--ignore-immutable] [--at-operation] [--debug] [--color] [--quiet] [--no-pager] [--config] [--config-file] [-h|--help] [FILESETS]

DESCRIPTION
Move changes from a revision into another revision

With the `-r` option, moves the changes from the specified revision to the parent revision. Fails if there are several parent revisions (i.e., the given revision is a merge).

With the `--from` and/or `--into` options, moves changes from/to the given revisions. If either is left out, it defaults to the working-copy commit. For example, `jj squash --into @--` moves changes from the working-copy commit to the grandparent.

If, after moving changes out, the source revision is empty compared to its parent(s), and `--keep-emptied` is not set, it will be abandoned. Without `--interactive` or paths, the source revision will always be empty.

If the source was abandoned and both the source and destination had a non-empty description, you will be asked for the combined description. If either was empty, then the other one will be used.

If a working-copy commit gets abandoned, it will be given a new, empty commit. This is true in general; it is not specific to this command.

EXPERIMENTAL FEATURES

An alternative squashing UI is available via the `-o`, `-A`, and `-B` options. Using any of these options creates a new commit. They can be used together with one or more `--from` options (if no `--from` is specified, `--from @` is assumed).

OPTIONS

-r, --revision <REVSET>
    Revision to squash into its parent (default: @). Incompatible with the experimental `-o`/`-A`/`-B` options

-f, --from <REVSETS>
    Revision(s) to squash from (default: @)

-t, --into <REVSET>
    Revision to squash into (default: @)

-o, --onto <REVSETS>
    (Experimental) The revision(s) to use as parent for the new commit (can be repeated to create a merge commit)

-A, --insert-after <REVSETS>
    (Experimental) The revision(s) to insert the new commit after (can be repeated to create a merge commit)

-B, --insert-before <REVSETS>
    (Experimental) The revision(s) to insert the new commit before (can be repeated to create a merge commit)

-m, --message <MESSAGE>
    The description to use for squashed revision (don't open editor)

-u, --use-destination-message
    Use the description of the destination revision and discard the description(s) of the source revision(s)

--editor
    Open an editor to edit the change description Forces an editor to open when using `--message` to allow the message to be edited afterwards.

-i, --interactive
    Interactively choose which parts to squash

--tool <NAME>
    Specify diff editor to be used (implies --interactive)

-k, --keep-emptied
    The source revision will not be abandoned

-h, --help
    Print help (see a summary with '-h')

[FILESETS]
    Move only changes to these paths (instead of all paths)

GLOBAL OPTIONS

-R, --repository <REPOSITORY>
    Path to repository to operate on By default, Jujutsu searches for the closest .jj/ directory in an ancestor of the current working directory.

--ignore-working-copy
    Don't snapshot the working copy, and don't update it By default, Jujutsu snapshots the working copy at the beginning of every command. The working copy is also updated at the end of the command, if the command modified the working-copy commit (`@`). If you want to avoid snapshotting the working copy and instead see a possibly stale working-copy commit, you can use `--ignore-working-copy`. This may be useful e.g. in a command prompt, especially if you have another process that commits the working copy. Loading the repository at a specific operation with `--at-operation` implies `--ignore-working-copy`.

--ignore-immutable
    Allow rewriting immutable commits By default, Jujutsu prevents rewriting commits in the configured set of immutable commits. This option disables that check and lets you rewrite any commit but the root commit. This option only affects the check. It does not affect the `immutable_heads()` revset or the `immutable` template keyword.

--at-operation <AT_OPERATION>
    Operation to load the repo at Operation to load the repo at. By default, Jujutsu loads the repo at the most recent operation, or at the merge of the divergent operations if any. You can use `--at-op=<operation ID>` to see what the repo looked like at an earlier operation. For example `jj --at-op=<operation ID> st` will show you what `jj st` would have shown you when the given operation had just finished. `--at-op=@` is pretty much the same as the default except that divergent operations will never be merged. Use `jj op log` to find the operation ID you want. Any unambiguous prefix of the operation ID is enough. When loading the repo at an earlier operation, the working copy will be ignored, as if `--ignore-working-copy` had been specified. It is possible to run mutating commands when loading the repo at an earlier operation. Doing that is equivalent to having run concurrent commands starting at the earlier operation. There's rarely a reason to do that, but it is possible.

--debug
    Enable debug logging

--color <WHEN>
    When to colorize output
    [possible values: always, never, debug, auto]

--quiet
    Silence non-primary command output For example, `jj file list` will still list files, but it won't tell you if the working copy was snapshotted or if descendants were rebased. Warnings and errors will still be printed.

--no-pager
    Disable the pager

--config <NAME=VALUE>
    Additional configuration options (can be repeated) The name should be specified as TOML dotted keys. The value should be specified as a TOML expression. If string value isn't enclosed by any TOML constructs (such as array notation), quotes can be omitted.

--config-file <PATH>
    Additional configuration files (can be repeated)